/***************************************************************************
 *   Copyright (C) 2006 by Borko Boskovic, Ales Zamuda                     *
 *   borko.boskovic@uni-mb.si, ales.zamuda@uni-mb.si                       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include<glib.h>
#include "asm.h"

/**
 * guint indexOfFirstBit64(guint64* x)
 * ???
 * \param x ???
 * \return ???
 */
guint indexOfFirstBit64(guint64 * x){ /* Mona pohitritev ? */
	gint result;
	__asm__(
	#ifdef m64
	"bsf (%%rdi),%%rax\n\t"
	:"=a" (result)
	:"d" (x)
	#else
	"bsf\t(%%ebx), %%eax\n\t"
	"jnz\t1f\n\t"
	"bsf\t4(%%ebx), %%eax\n\t"
	"add\t$32, %%eax\n"
	"1:\n\t"
	:"=a" (result)
	:"b" (x)
	#endif
	);
	return result;
}


guint indexOfLastBit64(guint64 * x){
	guint result;
	__asm__ (
	#ifdef m64
	"bsr (%%rdi),%%rax\n\t"
	:"=a" (result)
	:"d" (x)
	#else
	"bsr\t4(%%ebx), %%eax\n\t"
	"jnz\t1f\n\t"
	"bsr\t(%%ebx), %%eax\n\t"
	"jmp\t2f\n\t"
	"1:\n\t"
	"add\t$32, %%eax\n"
	"2:\n\t"
	:"=a" (result)
	:"b" (x)
	#endif
	);
	return result;
}

/**
 * guint getFirstBitAndClear64(guint64* x)
 * ???
 * \param x ???
 * \return ???
 */
guint getFirstBitAndClear64(guint64* x){ /* Mona pohitritev */
	guint result;
	__asm__(
	#ifdef m64
	"bsf (%%rdi), %%rcx\n\t"
	"mov $1, %%rbx\n\t"
	"shl %%cl, %%rbx\n\t"
	"xor %%rbx, (%%rdi)\n\t"
	"mov %%rcx, %%rax\n\t"
	:"=a" (result)
	:"d" (x)
	:"rcx", "rbx"
	#else
	"bsf (%%ebx), %%ecx\n\t"
	"jnz 1f\n\t"
	"add $4, %%ebx\n\t"
	"bsf (%%ebx), %%ecx\n\t"
	"add $32, %%ecx\n"
	"1:\n\t"
	"mov %%ecx, %%eax\n\t"
	"mov $1, %%edx\n\t"
	"shl %%cl, %%edx\n\t"
	"xor %%edx, (%%ebx)\n\t"
	:"=a" (result)
	:"b" (x)
	:"ecx", "edx"
	#endif
	);
	return result;
}
