/***************************************************************************
 *   Copyright (C) 2006 by Borko Boskovic                                  *
 *   borko.boskovic@uni-mb.si                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/**
 * \file engine.h
 * Engine maintenance functins. Engine is stopped with engineRun(char book[]) and
 * stopped with engineStop(), which is called uppon search timer expiration.
 * Engine is in its own thread, making it possible for UCI communicatin module
 * to be responsive all the time, even if search is currently in process.
 */

#ifndef ENGINE_H
#define ENGINE_H

#include <glib.h>

/** Runs the engine, called from main function.
 * \param book opening book to use
 */
void engineRun(gchar book[]);

/**
 * Stops engine timer (only the timer resource), without stopping the search.
 * To stop search, searchStop() must be called.
 */
void engineStopTimer();

#endif
